// test.cpp : Definiert den Einsprungpunkt fr die Konsolenanwendung.
//

#include "stdafx.h"
#include "math.h"
#include "..\MathParser\MathParser.h"

int main(int argc, char* argv[]){
	double varvalues[] = { 5, 6.1,0.1 };
	CMathParser mp;
	mp.Parameters.AddString("X", varvalues );
	mp.Parameters.AddString("Y", varvalues+1 );
	mp.Parameters.AddString("SOME_VERY_LONG_VARIABLE_NAME", varvalues+2 );

	double result;
	char formula[]="sqrt(x) + sin(y)+pi+SOME_VERY_LONG_VARIABLE_NAME";
	char *ErrMsg = mp.Parse( formula, &result );
	printf("%s = ",formula);
	if ( ErrMsg == NULL )
		printf( "%.15G\n", result );
	else{
		puts( ErrMsg );
		return 0;
	}
	
	printf("calculated in C++: %.15G\n", sqrt(varvalues[0]) + sin(varvalues[1])+3.14159265358979323846+varvalues[2]);
	varvalues[0] = 2;
	mp.Parameters.Replace("X", varvalues);
	ErrMsg = mp.Parse( formula, &result );
	printf("after changing the variable value:");
	if ( ErrMsg == NULL )
		printf( "%.15G\n", result );
	else
		puts( ErrMsg );
	return 0;
}